
#ifndef _MOM_BITSTREAM_I_H_
#define _MOM_BITSTREAM_I_H_


#include "momusys.h"
//#include "mom_bitstream_i.p"

/* Bitstreams are reallocated in steps of BITSTREAM_ALLOC_SIZE */

#define BITSTREAM_ALLOC_SIZE 256

typedef struct {
  Int val, len;
} VLCtab;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

Image * 	BitstreamInit _P_((void));
Void  	BitstreamFree _P_((	Image *bitstream
	));
Void  	BitstreamPutBit _P_((	Image *bitstream,
			SInt bit
	));
Void  	BitstreamPutBits _P_((	Image *bitstream,
			UInt bits,
			UInt nbits
	));
UInt  	BitstreamPut _P_((	Image *b_stream,
			Int index1,
			Int index2
	));


Void  	InitBits _P_((	Int index1,
			Int index2
	));
Void  	PutBits _P_((	Int n,
			Int val,
			Int index1,
			Int index2
	));
Int  	CloseBits _P_((	Int index1,
			Int index2
	));
Int  	NextStartCode _P_((	Int index1,
			Int index2
	));
Int  	NextResyncMarker _P_((	Int index1,
			Int index2
	));

#ifdef __cplusplus
}
#endif /* __cplusplus  */ 

#endif /* _MOM_BITSTREAM_I_H_ */

